<?php
namespace WPoductsImageAccordion;

define( "WOOCIAP_ASFSK_ASSETS_ADMIN_DIR_FILE", plugin_dir_url( __FILE__ ) . "assets/admin" );

class Classwoociapimageaccordion {

	private static $_instance = null;

	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function woociap_admin_editor_scripts() {
		add_filter( 'script_loader_tag', [ $this, 'woociap_admin_editor_scripts_as_a_module' ], 10, 2 );
	}

	public function woociap_admin_editor_scripts_as_a_module( $tag, $handle ) {
		if ( 'woociap_the_pricing_editor' === $handle ) {
			$tag = str_replace( '<script', '<script type="module"', $tag );
		}

		return $tag;
	}

	private function include_widgets_files() {
		require_once( __DIR__ . '/widgets/woociap-imageaccordion.php' );
	}

	public function woociap_register_widgets() {
		// Its is now safe to include Widgets files
		$this->include_widgets_files();

		// Register Widgets
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new Widgets\woociapImageAccordion() );
	}

	// Register Category
	function woociap_add_elementor_widget_categories( $elements_manager ) {

		$elements_manager->add_category(
			'woociap-image-accordion-category',
			[
				'title' => esc_html__( 'WPoducts Image Accordion', 'wproduct-image-accordion' ),
				'icon' => 'eicon-person',
			]
		);
	}
	public function woociap_all_assets_for_the_public(){
		wp_enqueue_style( 'woociap_image_accordion_style_css', 'https://bwd-elementor-addons-pro.netlify.app/woo-imgaccordion.css', null, '2.1', 'all');
	}
	public function woociap_all_assets_for_elementor_editor_admin(){
		$all_css_js_file = array(
            'woociap_image_accordion_admin_icon_css' => array('woociap_path_admin_define'=>WOOCIAP_ASFSK_ASSETS_ADMIN_DIR_FILE . '/icon.css'),
        );
        foreach($all_css_js_file as $handle => $fileinfo){
            wp_enqueue_style( $handle, $fileinfo['woociap_path_admin_define'], null, '2.1', 'all');
        }
	}

	public function __construct() {
		// For public assets
		add_action('wp_enqueue_scripts', [$this, 'woociap_all_assets_for_the_public']);

		// For Elementor Editor
		add_action('elementor/editor/before_enqueue_scripts', [$this, 'woociap_all_assets_for_elementor_editor_admin']);
		
		// Register Category
		add_action( 'elementor/elements/categories_registered', [ $this, 'woociap_add_elementor_widget_categories' ] );

		// Register widgets
		add_action( 'elementor/widgets/widgets_registered', [ $this, 'woociap_register_widgets' ] );

		// Register editor scripts
		add_action( 'elementor/editor/after_enqueue_scripts', [ $this, 'woociap_admin_editor_scripts' ] );
		
	}
}

// Instantiate Plugin Class
Classwoociapimageaccordion::instance();